module  display_sel(
                    clk         ,
                    rst_n       ,
                    cal_state   ,
                    op_1        ,
                    op_2        ,
                    result      ,
                    result_neg  ,
                    display     ,
                    div_rem_tmp ,////////////////
                    display_vld 
                    );

    parameter   KEY_WID     =   4           ;
    parameter   STATE_WID   =   5           ;
    parameter   NUM_WID     =   27          ;
    parameter   SEG_NUM     =   8           ;
    parameter   CNT_WID     =   4           ;
    parameter   DIS_WID     =   SEG_NUM*4   ;
    parameter   OP_1        =   5'b00001    ;
    parameter   OPER        =   5'b00010    ;
    parameter   OP_2        =   5'b00100    ;
    parameter   RESULT      =   5'b01000    ;
    parameter   ERROR       =   5'b10000    ;

    //źŶ
    input                           clk         ;
    input                           rst_n       ;
    input   [STATE_WID-1:0]         cal_state   ;
    input   [NUM_WID-1:0]           op_1        ;
    input   [NUM_WID-1:0]           op_2        ;
    input   [NUM_WID-1:0]           result      ;
    input                           result_neg  ;  

    //źŶ
    output  [DIS_WID-1:0]           display     ;
    output                          display_vld ;
    output  [CNT_WID-1:0]           div_rem_tmp ;/////////////////////////
    
       
    //źreg
    reg     [DIS_WID-1:0]           display     ;
    reg                             display_vld ;
    
    reg                             result_neg_tmp;
    reg     [NUM_WID-1:0]           dis_sel     ;
    reg     [NUM_WID-1:0]           dis_sel_tmp ;
    wire    [NUM_WID-1:0]           div_quo     ;
    wire    [CNT_WID-1:0]           div_rem     ;
    reg     [CNT_WID-1:0]           dis_cnt     ;   
    wire    [NUM_WID-1:0]           dis_tmp     ;
   assign div_rem_tmp = div_rem;//////////////////// 

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        result_neg_tmp <= 0;
    end
    else begin
        result_neg_tmp <= result_neg;
    end
end

always  @(*)begin
    if(cal_state==OP_2)begin
        dis_sel = op_2;
    end
    else begin
        dis_sel = op_1;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dis_sel_tmp <= 0;
    end
    else begin
        dis_sel_tmp <= dis_sel;
    end
end

div div_prj(
            .clock      (clk        )   ,
            .numer      (dis_tmp    )   ,
            .denom      (10         )   ,
            .quotient   (div_quo    )   ,
            .remain     (div_rem    )
            );

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dis_cnt <= 0;
    end
    else if(dis_sel!=dis_sel_tmp || result_neg!=result_neg_tmp)begin
        dis_cnt <= 4'd9;
    end
    else if(dis_cnt==0)begin
        dis_cnt <= dis_cnt;
    end
    else begin
        dis_cnt <= dis_cnt - 1'b1;
    end
end

assign  dis_tmp = dis_cnt==9 ? dis_sel : div_quo;

integer ii;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        display <= 0;
    end
    else begin
        for(ii=0;ii<SEG_NUM;ii=ii+1)begin
            if(cal_state==ERROR)begin//źţF
                display[4*(ii+1)-1 -:4] <= 4'd11;
            end
            else if(dis_cnt==9)begin
                display[4*(ii+1)-1 -:4] <= 0;
            end
            else if(ii==SEG_NUM-1 && result_neg==1 && cal_state!=OP_2)begin//
                display[4*(ii+1)-1 -:4] <= 4'd10;
            end
            else if((ii+dis_cnt)==8)begin
                display[4*(ii+1)-1 -:4] <= div_rem;
            end
            else begin
                display[4*(ii+1)-1 -:4] <= display[4*(ii+1)-1 -:4];
            end
        end
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        display_vld <= 0;
    end
    else begin
        display_vld <= (dis_cnt==0 && (dis_sel==dis_sel_tmp)) ? 1'b1 : 1'b0;
    end
end

endmodule
