module  op_2(
                clk         ,
                rst_n       ,
                key_num_out ,
                key_vld_out ,
                cal_state   ,
                op_1        ,
                op_2        ,
                op_2_err    
            );

    parameter   KEY_WID     =   4       ;
    parameter   STATE_WID   =   5       ;
    parameter   NUM_WID     =   27      ;
    parameter   OP_1        =   5'b00001;
    parameter   OPER        =   5'b00010;
    parameter   OP_2        =   5'b00100;
    parameter   RESULT      =   5'b01000;
    parameter   ERROR       =   5'b10000;

    //źŶ
    input                   clk         ;
    input                   rst_n       ;
    input   [KEY_WID-1:0]   key_num_out ;
    input                   key_vld_out ;
    input   [STATE_WID-1:0] cal_state   ;
    input   [NUM_WID-1:0]   op_1        ;

    //źŶ
    output  [NUM_WID-1:0]   op_2        ;
    output                  op_2_err    ;
       
    //źreg
    reg     [NUM_WID-1:0]   op_2        ;
    reg                     op_2_err    ;

    wire                    key_num_en  ;
    wire                    key_op_en   ;
    wire                    key_cal_en  ;
    wire                    key_back_en ;
    reg     [STATE_WID-1:0] pre_state   ;

assign  key_num_en = (key_num_out==0 || key_num_out==1 || key_num_out==2 || key_num_out==3 || key_num_out==4 || key_num_out==5 || key_num_out==6 || key_num_out==7 || key_num_out==8 || key_num_out==9) && key_vld_out==1;
assign  key_op_en = (key_num_out==10 || key_num_out==11 || key_num_out==12 || key_num_out==13) && key_vld_out==1;
assign  key_cal_en = key_num_out==15 && key_vld_out==1; 
assign  key_back_en = key_num_out==14 && key_vld_out==1;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        pre_state <= 0;
    end
    else begin
        pre_state <= cal_state;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        op_2 <= 0;
    end
    else if(cal_state==OPER)begin//OPER״̬
        op_2 <= 0;
    end
    else if(pre_state==OPER && cal_state==OP_2)begin//״̬,
        op_2 <= key_num_out;
    end
    else if(cal_state==OP_2 && key_back_en==1)begin//OP_2״̬°˸
        op_2 <= op_2 / 10;
    end
    else if(cal_state==OP_2 && key_num_en==1)begin//OP_2״̬°֣жop_2ĳǷﵽ8λ
        op_2 <= (op_2>9999999) ? op_2 : (op_2*10+key_num_out);
    end
    else begin
        op_2 <= op_2;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        op_2_err <= 0;
    end
    else if(cal_state==OP_2 && key_num_en==1 && op_2>9999999)begin
        op_2_err <= 1'b1;
    end
    else begin
        op_2_err <= 1'b0;
    end
end

endmodule


