module  oper(
                clk         ,
                rst_n       ,
                key_num_out ,
                key_vld_out ,
                cal_state   ,
                oper        
            );

    parameter   KEY_WID     =   4       ;
    parameter   STATE_WID   =   5       ;
    parameter   OP_1        =   5'b00001;
    parameter   OPER        =   5'b00010;
    
    //źŶ
    input                   clk         ;
    input                   rst_n       ;
    input   [KEY_WID-1:0]   key_num_out ;
    input                   key_vld_out ;
    input   [STATE_WID-1:0] cal_state   ;

    //źreg
    output  [KEY_WID-1:0]   oper        ;

    reg     [KEY_WID-1:0]   oper        ;
    wire                    key_op_en   ;

assign  key_op_en = (key_num_out==10 || key_num_out==11 || key_num_out==12 || key_num_out==13) && key_vld_out==1;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        oper <= 0;
    end
    else if(cal_state==OP_1)begin
        oper <= 0;
    end
    else if(key_op_en==1)begin
        oper <= key_num_out;
    end
    else begin
        oper <= oper;
    end
end

endmodule

