module  result(
                clk         ,
                rst_n       ,
                key_num_out ,
                key_vld_out ,
                cal_state   ,
                op_1        ,
                oper        ,
                op_2        ,
                result      ,
                result_neg  ,
                result_err  
            );

    parameter   KEY_WID     =   4       ;
    parameter   STATE_WID   =   5       ;
    parameter   NUM_WID     =   27      ;
    parameter   OP_1        =   5'b00001;
    parameter   OPER        =   5'b00010;
    parameter   OP_2        =   5'b00100;
    parameter   RESULT      =   5'b01000;
    parameter   ERROR       =   5'b10000;
    parameter   ADD         =   10      ;
    parameter   DEV         =   11      ;
    parameter   MUL         =   12      ;
    parameter   DIV         =   13      ;

    //źŶ
    input                   clk         ;
    input                   rst_n       ;
    input   [KEY_WID-1:0]   key_num_out ;
    input                   key_vld_out ;
    input   [STATE_WID-1:0] cal_state   ;
    input   [NUM_WID-1:0]   op_1        ;
    input   [KEY_WID-1:0]   oper        ;
    input   [NUM_WID-1:0]   op_2        ;

    //źŶ
    output  [NUM_WID-1:0]   result      ;
    output                  result_neg  ;
    output                  result_err  ;
       
    //źreg
    reg     [NUM_WID-1:0]   result      ;
    reg                     result_neg  ;
    reg                     result_err  ;

    wire                    key_op_en   ;
    wire                    key_cal_en  ;
    wire                    calculate   ;
    reg     [STATE_WID-1:0] pre_state   ;
    //wire    [NUM_WID-1:0]   div_result  ;  
      
/*
div_fast    div_fast_res(
                            .denom(op_2),
	                        .numer(op_1),
	                        .quotient(div_result),
	                        .remain(remain)
                        );
 */  

assign  key_op_en = (key_num_out==10 || key_num_out==11 || key_num_out==12 || key_num_out==13) && key_vld_out==1;
assign  key_cal_en = key_num_out==15 && key_vld_out==1;
assign  calculate = (pre_state==OP_2 && cal_state==OPER || key_cal_en==1);

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        pre_state <= 0;
    end
    else begin
        pre_state <= cal_state;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        result <= 0;
    end
    else if(calculate==1)begin//ʱ
        case(oper)
            ADD:begin
                if(result_neg==0)begin
                    result <= op_1 + op_2;
                end
                else begin
                    result <= (op_1>op_2) ? (op_1 - op_2) : (op_2 - op_1);
                end
            end
            DEV:begin
                if(result_neg==0)begin
                    result <= (op_1>op_2) ? (op_1 - op_2) : (op_2 - op_1);
                end
                else begin
                    result <= op_1 + op_2;
                end
            end
            MUL:begin
                result <= op_1 * op_2;
            end
            DIV:begin
                result <= op_1 / op_2;//div_result;
            end
            default:begin
                result <= op_1;
            end
        endcase
    end
    else begin
        result <= result;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        result_neg <= 0;
    end
    else if(cal_state==OP_1)begin//OP_1״̬£ʾ½
        result_neg <= 1'b0;
    end
    else if(pre_state==ERROR)begin//ERROR״̬
        result_neg <= 1'b0;
    end
    else if(calculate==1 && oper==DEV && op_1<op_2)begin//ʱ
        result_neg <= 1'b1;
    end
    else if(calculate==1 && result_neg==1 && oper==ADD && op_1<=op_2)begin//ʱ
        result_neg <= 1'b0;
    end
    else if(result==0)begin//0
        result_neg <= 1'b0;
    end
    else begin
        result_neg <= result_neg;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        result_err <= 0;
    end
    else if(cal_state==OP_1)begin//OP_1״̬£ʾ½
        result_err <= 1'b0;
    end
    else if((pre_state==OP_2 && cal_state==OPER) || (key_cal_en==1 && pre_state!=ERROR))begin//ʱ
        case(oper)
            ADD:begin
                if(result_neg==0)begin
                    result_err <= (op_1+op_2)>9999_9999 ? 1'b1 : 1'b0;
                end
                else begin
                    result_err <= 1'b0;
                end
            end
            DEV:begin
                if(result_neg==1)begin
                    result_err <= (op_1+op_2)>999_9999 ? 1'b1 : 1'b0;
                end
                else if(op_2>op_1)begin
                    result_err <= (op_2-op_1)>999_9999 ? 1'b1 : 1'b0;
                end
                else begin
                    result_err <= 1'b0;
                end
            end
            MUL:begin
                if(result_neg==1)begin
                    result_err <= (op_1*op_2)>999_9999 ? 1'b1 : 1'b0;
                end
                else begin
                    result_err <= (op_1*op_2)>9999_9999 ? 1'b1 : 1'b0;
                end
            end
            DIV:begin
                if(op_2==0)begin
                    result_err <= 1'b1;
                end
                else begin
                    result_err <= 1'b0;
                end
            end
            default:begin
                result_err <= 1'b0;
            end
        endcase 
    end 
    else begin
        result_err <= 1'b0;
    end
end

endmodule
