module  work_state(
                    clk         ,
                    rst_n       ,
                    key_num     ,
                    key_vld     ,
                    result_err  ,
                    key_num_out ,
                    key_vld_out ,
                    cal_state
                );

    parameter   KEY_WID     =   4;
    parameter   STATE_WID   =   5;  
    parameter   OP_1        =   5'b00001;
    parameter   OPER        =   5'b00010;
    parameter   OP_2        =   5'b00100;
    parameter   RESULT      =   5'b01000;
    parameter   ERROR       =   5'b10000;

    //źŶ
    input                   clk         ;
    input                   rst_n       ;
    input   [KEY_WID-1:0]   key_num     ;
    input                   key_vld     ;
    input                   result_err  ;

    //źŶ
    output  [KEY_WID-1:0]   key_num_out ;
    output                  key_vld_out ;
    output  [STATE_WID-1:0] cal_state   ;

    //źreg
    reg     [KEY_WID-1:0]   key_num_out ;
    reg                     key_vld_out ;
    reg     [STATE_WID-1:0] cal_state   ;

    reg     [KEY_WID-1:0]   key_num_chg ;    
    wire                    key_num_en  ;
    wire                    key_op_en   ;
    wire                    key_cal_en  ;
    wire                    key_back_en ;
    reg     [STATE_WID-1:0] next_state  ;

always  @(*)begin
    case(key_num)
        4'd0:begin
            key_num_chg = 4'd7;
        end
        4'd1:begin
            key_num_chg = 4'd8;
        end
        4'd2:begin
            key_num_chg = 4'd9;
        end
        4'd3:begin
            key_num_chg = 4'd10;
        end
        4'd7:begin
            key_num_chg = 4'd11;
        end
        4'd8:begin
            key_num_chg = 4'd1;
        end
        4'd9:begin
            key_num_chg = 4'd2;
        end
        4'd10:begin
            key_num_chg = 4'd3;
        end
        4'd11:begin
            key_num_chg = 4'd14;
        end
        4'd12:begin
            key_num_chg = 4'd0;
        end
        4'd13:begin
            key_num_chg = 4'd12;
        end
        4'd14:begin
            key_num_chg = 4'd13;
        end
        default:begin
            key_num_chg = key_num;
        end
    endcase
end

assign  key_num_en = (key_num_chg==0 || key_num_chg==1 || key_num_chg==2 || key_num_chg==3 || key_num_chg==4 || key_num_chg==5 || key_num_chg==6 || key_num_chg==7 || key_num_chg==8 || key_num_chg==9) && key_vld==1;
assign  key_op_en = (key_num_chg==10 || key_num_chg==11 || key_num_chg==12 || key_num_chg==13) && key_vld==1;
assign  key_cal_en = key_num_chg==15 && key_vld==1; 
assign  key_back_en = key_num_chg==14 && key_vld==1;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        cal_state <= OP_1;
    end
    else begin
        cal_state <= next_state;
    end
end

always  @(*)begin
    if(result_err==1)begin
        next_state = ERROR;
    end
    else begin
        case(cal_state)
            OP_1:begin
                if(key_op_en==1)begin//
                    next_state = OPER;
                end
                else if(key_cal_en==1)begin//µȺ
                    next_state = RESULT;
                end
                else begin
                    next_state = OP_1;
                end
            end
            OPER:begin
                if(key_num_en==1)begin//
                    next_state = OP_2;
                end
                else if(key_cal_en==1)begin//µȺ
                    next_state = RESULT;
                end
                else begin
                    next_state = OPER;
                end
            end
            OP_2:begin
                if(key_op_en==1)begin//
                    next_state = OPER;
                end
                else if(key_cal_en==1)begin//µȺ
                    next_state = RESULT;
                end
                else begin
                    next_state = OP_2;
                end
            end
            RESULT:begin
                if(key_num_en==1)begin//
                    next_state = OP_1;
                end
                else if(key_op_en==1)begin//
                    next_state = OPER;
                end
                else begin
                    next_state = RESULT;
                end
            end
            ERROR:begin
                if(key_num_en==1)begin
                    next_state = OP_1;
                end
                else begin
                    next_state = ERROR;
                end
            end
            default:begin
                next_state = cal_state;
            end
        endcase
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        key_num_out <= 0;
    end
    else begin
        key_num_out <= key_num_chg;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        key_vld_out <= 0;
    end
    else begin
        key_vld_out <= key_vld;
    end
end

endmodule
